// test_ocxDlg.cpp : implementation file
//

#include "stdafx.h"
#include "test_ocx.h"
#include "test_ocxDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTest_ocxDlg dialog

CTest_ocxDlg::CTest_ocxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTest_ocxDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTest_ocxDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
}

void CTest_ocxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTest_ocxDlg)
	DDX_Control(pDX, IDC_VICX, m_Vicx);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTest_ocxDlg, CDialog)
	//{{AFX_MSG_MAP(CTest_ocxDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest_ocxDlg message handlers

BOOL CTest_ocxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	if(!m_Vicx.OpenVicx()) {
		MessageBox("Error application !","Error",MB_OK | MB_ICONSTOP);
		ExitProcess(0);
	}
	Port = m_Vicx.OpenPrt(0x70,1,2);
	SetTimer(10,1000,0);
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTest_ocxDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTest_ocxDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTest_ocxDlg::OnTimer(UINT nIDEvent) 
{
	m_Vicx.WP(Port,0,0x32);//Write to port 0x70
	Sleep(1);
	yearHigh = m_Vicx.RP(Port,1);//Read from port 0x71

	m_Vicx.WP(Port,0,0x09);
	Sleep(1);
	yearLow  = m_Vicx.RP(Port,1);

	m_Vicx.WP(Port,0,0x08);
	Sleep(1);
	month = m_Vicx.RP(Port,1);

	m_Vicx.WP(Port,0,0x07);
	Sleep(1);
	day = m_Vicx.RP(Port,1);

	m_Vicx.WP(Port,0,0x04);
	Sleep(1);
	hour = m_Vicx.RP(Port,1);

	m_Vicx.WP(Port,0,0x02);
	Sleep(1);
	min = m_Vicx.RP(Port,1);

	m_Vicx.WP(Port,0,0x00);
	Sleep(1);
	sec = m_Vicx.RP(Port,1);

	
	sprintf(t,"%0.2x/%0.2x/%0.4x   %0.2x:%0.2x:%0.2x",day,month,yearHigh*0x100+yearLow,hour,min,sec);
	SetDlgItemText(IDC_DT,t);
	CDialog::OnTimer(nIDEvent);
}

void CTest_ocxDlg::OnOK() 
{
	m_Vicx.ClosePrt(Port);
	m_Vicx.CloseVicx();
	CDialog::OnOK();
}

void CTest_ocxDlg::OnCancel()
{
	m_Vicx.ClosePrt(Port);
	m_Vicx.CloseVicx();
	CDialog::OnCancel();
}
